#include <stdlib.h>
#include <sys/wait.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>

int p[2],q[2];

// Utilisation de deux pipe pour créer un canal de communication
// dans les deux sens. Ici, on s'en sert pour convertir quelques
// caractères Unicode. (uconv doit être installé dans ce cas,
// mais le principe marche avec n'importe quel programme.)

void pere ()
{
	char *s = "Ĳ ﬀ ½\n";
	char *t = malloc(100);

	close(p[0]); close(q[1]);
	write(p[1],s,strlen(s));
	close(p[1]);
	t[read(q[0],t,100)] = 0;
	close(q[0]);
	printf("la sortie est %s\n",t);
}

void fils ()
{
	dup2(p[0],0);
	dup2(q[1],1);
	close(p[0]); close(q[0]);
	close(p[1]); close(q[1]);
	execlp("uconv","uconv","-x","NFKD",NULL);
}

int main()
{
	pipe(p);
	pipe(q);
	if (fork()) pere(); else fils();
}

